# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTIBILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
# ======================================================================

__version__= '1.0'

from Globals import HTML, HTMLFile, DTMLFile, MessageDialog, Persistent
import OFS,Acquisition, AccessControl.Role
import Globals, sys, traceback
from OFS.DTMLDocument import DTMLDocument

from OFS.History import Historical, html_diff
from OFS.SimpleItem import SimpleItem
from OFS.Cache import Cacheable

import string,Products.PythonScripts






class PSP(OFS.SimpleItem.Item,DTMLDocument):
    """Zope object."""    
       
    meta_type = 'Python Server Page'
    icon = 'misc_/PSP/icon'
    
    #manage_opt = HTMLFile('dtml/options', globals())



    #manage tabs
    manage_options=(
                    {'label':'edit','action':'manage_main'},
                    {'label':'view','action':''},
                    {'label':'script','action':'internal_script/manage_workspace'},
                   ) + Historical.manage_options + SimpleItem.manage_options + Cacheable.manage_options
                   


    def __init__(self, id, title):
        """ init method """
        self.id=id
        self.globals=''
        self._vars=''
        self.compiled=0
        self.raw="""<%=self.standard_html_header(self)%>
<h1>Hello World</h1>
<%=self.standard_html_footer(self)%>
"""
        
        self.internal_script = Products.PythonScripts.PythonScript.PythonScript('internal_script')
        self.internal_script.ZPythonScript_setTitle('internal generated python script')
        self.internal_script.ZPythonScript_edit('','')
        



    
    def __call__(self, client=None, REQUEST={}, RESPONSE=None, **kw):
        """ called when view or call object """
        if self.compiled==0:
            self._compile()
        return self.internal_script()
    
        

    def manage_edit(self,data,title,SUBMIT='Change',dtpref_cols='50',dtpref_rows='20',REQUEST=None):
        """
        called from zope web interface when edit
        """
        ret = DTMLDocument.manage_edit(self,data,title,SUBMIT,dtpref_cols,dtpref_rows,REQUEST)
        self._compile()
        return ret

    def manage_upload(self,file='', REQUEST=None):
        """ called when upload from zope web interface """
        ret = DTMLDocument.manage_upload(self,file,REQUEST)
        self._compile()
        return ret
    

    def PUT(self, REQUEST, RESPONSE):
        """ PUT method - called when webdav or ftp PUT data"""
        DTMLDocument.PUT(self,REQUEST, RESPONSE)
        self._compile()
        return RESPONSE


    def _compile(self):
        """
           implemented tags:
           
           <% ... python code ... %>
           <%= ... variables, expressions ... %>
           
        """
        ret='''
#
#Python server page
#
self=context.REQUEST.PARENTS[0]

'''
        flag=0
        s=self.raw
        while(1):
            n=len(s)
            if n==0: break
            try:    ix_code = s.index("<%")
            except: ix_code = n
            try:    ix_var = s.index("<%=")
            except: ix_var = n
            try:    ix_end = s.index("%>")
            except: ix_end = n+1
            if ix_var!=n:
                if ix_var<=ix_code:
                    flag=1
                    if ix_var>0:
                        ret=ret+'''print """%s"""\n''' % (s[:ix_var]) 
                    ret=ret+"print "+s[ix_var+3:ix_end]+"\n"
                    s=s[ix_end+2:]
                    continue
            if ix_code!=n:
                if ix_code<ix_var:
                    if ix_code>0:
                        flag=1
                        ret=ret+'''print """%s"""\n''' % (s[:ix_code]) 
                    ret=ret+s[ix_code+2:ix_end]+"\n"
                    s=s[ix_end+2:]
                    continue
            flag=1
            ret=ret+'''print """%s"""\n''' % (s)
            break
        if flag==1: ret=ret+"return printed"
        self.internal_script.ZPythonScript_edit('',ret)
        self.compiled=1


Globals.default__class_init__(PSP)

